=== include/librealsense2/utilities/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2022 Intel Corporation. All Rights Reserved.

include(${CMAKE_CURRENT_LIST_DIR}/easylogging/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/concurrency/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/time/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/number/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/os/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/string/CMakeLists.txt)
