=== debian/changelog ===
ros-foxy-librealsense2 (2.51.1-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- LibRS ROS Team <librs.ros@intel.com>  Wed, 07 Sep 2022 13:34:17 -0000
