=== debian/control ===
Source: ros-foxy-librealsense2
Section: misc
Priority: optional
Maintainer: LibRS ROS Team <librs.ros@intel.com>
Build-Depends: debhelper (>= 9.0.0), dkms, libssl-dev, libudev-dev, libusb-1.0-0-dev, pkg-config, ros-foxy-ament-cmake, udev, ros-foxy-ros-workspace
Homepage: https://github.com/IntelRealSense/librealsense/
Standards-Version: 3.9.2

Package: ros-foxy-librealsense2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ros-workspace
Description: Library for controlling and capturing data from the Intel(R) RealSense(TM) D400 devices.
